<template>
  <CdxButton weight="primary" action="destructive" @click="open = true">
    <slot></slot>
  </CdxButton>
  <CdxDialog
    :open="open"
    title="Are you absolutely sure?"
    close-button-label="Close"
    :primary-action="{
      label: 'Yes, delete ' + nameOfTheThingToDelete,
      actionType: 'destructive',
      disabled: confirmationInput !== confirmationText,
    }"
    :default-action="{ label: 'Cancel, keep ' + nameOfTheThingToDelete }"
    @primary="onPrimaryAction()"
    @default="onDefaultAction()"
    @update:open="onDefaultAction()"
  >
    <strong>You are about to delete this {{ nameOfTheThingToDelete }}.</strong>

    <p><strong>The deletion is irreversible.</strong></p>

    <p>Enter the following to confirm:</p>
    <pre>{{ confirmationText }}</pre>

    <CdxTextInput v-model="confirmationInput" />
  </CdxDialog>
</template>

<script setup>
import { CdxButton, CdxDialog, CdxTextInput } from '@wikimedia/codex'
import { ref } from 'vue'

defineProps({
  confirmationText: {
    type: String,
    required: true,
  },
  nameOfTheThingToDelete: {
    type: String,
    required: true,
  },
})

const emit = defineEmits(['delete'])

const open = ref(false)
const confirmationInput = ref('')

function onPrimaryAction() {
  emit('delete')
  open.value = false
  confirmationInput.value = ''
}

function onDefaultAction() {
  open.value = false
  confirmationInput.value = ''
}
</script>
